unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ScktComp, StdCtrls;

type
  TParsedString = record        //tipo para separao de strings
    strings: array of string;
    count: integer;
  end;

  TForm1 = class(TForm)
    server: TServerSocket;
    bemVindo: TMemo;
    procedure serverClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure serverClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure serverClientRead(Sender: TObject; Socket: TCustomWinSocket);
  private
    { Private declarations }
  public
    procedure SalvarJog(jog: integer);
    procedure cmdLogin(jog: integer);
    procedure cmdSenha(jog: integer);
    procedure cmdNSenha1(jog: integer);
    procedure cmdNSenha2(jog: integer);
    procedure cmdAndando(jog: integer);
    procedure mandarPos(jog: integer);
    function TentarSair(jog: integer): boolean;
    procedure MandarConectados(jog: integer);
    procedure MandarTodos(s: string);
    function AcharJog(nome: string): integer;
    procedure Falar(jog: integer);
    procedure Dizer(jog: integer; str: TParsedString);
    procedure Pegar(jog: integer; str: TParsedString);
    procedure MostrarInv(jog: integer);
    procedure Soltar(jog: integer);
  end;

  TJogador = record
    nome: string;             //nome do jogador
    senha: string;            //senha
    posicao: string;          //a localizao dele no jogo
    inventario: string;       //os itens que ele tm
    socket: TCustomWinSocket; //o objeto responsvel pela conexo TCP
    cmd: string;              //o comando sendo digitado
    flag: integer;            //indica que posio da conexo ele est
  end;

const
  FLDESCONHECIDO = 0;  //flag desconhecida
  FLLOGIN        = 1;  //jog mandando nome
  FLSENHA        = 2;  //jog mandando senha
  FLNSENHA1      = 3;  //novo jog mandando senha
  FLNSENHA2      = 4;  //novo jog repetindo senha
  FLANDANDO      = 5;  //jogando



var
  Form1: TForm1;
  jogs: array of TJogador;
  
implementation

{$R *.DFM}

//divide uma string em um array de strings, separados pelo "caract"
function ParseString(str, caract: string): TParsedString;
var
p1: integer;
begin
     result.count:= 0;
     while true do begin
          p1:= pos(caract, str);
          if (p1 = 0) or (p1 = -1) then break;
          setLength(result.strings, result.count + 1);
          result.strings[result.count]:= copy(str, 1, p1 -1);
          str:= copy(str, p1 + 1, length(str));
          result.count:= result.count + 1;
     end;
     if length(str) > 0 then begin
          setlength(result.strings, result.count + 1);
          result.strings[result.count]:= str;
          result.count:= result.count + 1;
     end;
end;


procedure TForm1.serverClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
jog: integer;
p: Pointer;
begin
     jog:= length(jogs);
     setLength(jogs, jog + 1);        //aumentar lista
     jogs[jog].flag:= FLLOGIN;        //indicar posio do jogador
     socket.SendText(BemVindo.Text);  //texto de conexo
     getMem(p, 4);
     integer(p^):= jog;
     socket.Data:= p;                 //ligar jogador e socket
     jogs[jog].socket:= socket;       
end;

procedure TForm1.serverClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
jog: integer;
i: integer;
begin
     jog:= integer(socket.data^);            //achar jogador

     if fileExists(jogs[jog].nome) then   
          salvarJog(jog);                    //salvar

     freeMem(socket.data);                   //liberar memria
     for i:= jog to length(jogs) -2 do begin //copiar os jogadores da frente da lista para trs
          jogs[i]:= jogs[i + 1];
          integer(jogs[i].socket.Data^):= i;
     end;

     setLength(jogs, length(jogs) -1);       //reduzir lista
end;

procedure TForm1.SalvarJog(jog: integer);
var
stl: TStringList;
begin
     stl:= TStringList.create;
     stl.Add(jogs[jog].senha);
     stl.add(jogs[jog].posicao);
     stl.add(intToStr(jogs[jog].flag));
     stl.add(jogs[jog].inventario);
     stl.SaveToFile(jogs[jog].nome);
     stl.free;
end;


procedure TForm1.serverClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
cmd: string;
jog: integer;
begin
     cmd:= socket.ReceiveText;               //informao sendo recebida
     jog:= integer(socket.data^);            //acha o ndice do jogador
     if cmd = #13#10 then begin              //se for <enter>
          case jogs[jog].flag of             //executar funo relativa  flag
               FLLOGIN: cmdLogin(jog);
               FLSENHA: cmdSenha(jog);
               FLNSENHA1: cmdNSenha1(jog);
               FLNSENHA2: cmdNSenha2(jog);
               FLANDANDO: cmdAndando(jog);
          end;
          jogs[jog].cmd:= '';
     end else if cmd = #8 then              //se for <backspace>
          jogs[jog].cmd:= copy(jogs[jog].cmd, 1, length(jogs[jog].cmd) -1)
     else                                    //se for qualquer outro caracter
          jogs[jog].cmd:= jogs[jog].cmd + cmd;

end;

procedure TForm1.cmdLogin(jog: integer);
var
stl: TStringList;
begin
     jogs[jog].nome:= jogs[jog].cmd;              //pegar nome
     if fileExists(jogs[jog].nome) then begin     //se o jogador existe, carregar arquivo e pedir senha
          stl:= TStringList.create;
          stl.LoadFromFile(jogs[jog].cmd);
          jogs[jog].senha:= stl[0];
          jogs[jog].posicao:= stl[1];
          jogs[jog].flag:= FLSENHA;
          jogs[jog].inventario:= stl[3];
          jogs[jog].socket.SendText(#13#10 + 'Jogador existente. Digite sua senha: ');
          stl.free;
     end else begin                               //seno pedir nova senha
          jogs[jog].flag:= FLNSENHA1;
          jogs[jog].socket.SendText(#13#10 + 'Novo jogador. Digite sua senha: ');
     end;
end;

procedure TForm1.cmdSenha(jog: integer);
begin
     if jogs[jog].senha = jogs[jog].cmd then begin    //se a senha est correta
          jogs[jog].flag:= FLANDANDO;
          jogs[jog].socket.SendText(#13#10 + 'Jogador Conectado!');
          mandarPos(jog);
     end else begin
          jogs[jog].flag:= FLLOGIN;                   //se a senha est errada
          jogs[jog].socket.SendText(#13#10 + 'Senha incorreta! Digite seu nome: ');
     end;
end;


procedure TForm1.cmdNSenha1(jog: integer);
begin
     jogs[jog].senha:= jogs[jog].cmd;
     jogs[jog].flag:= FLNSENHA2;
     jogs[jog].socket.SendText(#13#10 + 'Digite sua senha novamente: ');
end;

procedure TForm1.cmdNSenha2(jog: integer);
begin
     if jogs[jog].senha <> jogs[jog].cmd then begin     //se forem diferentes
          jogs[jog].flag:= FLNSENHA1;
          jogs[jog].socket.SendText(#13#10 + 'Senhas diferentes. Digite sua senha: ');
     end else begin                                     //se forem iguais
          jogs[jog].flag:= FLANDANDO;
          jogs[jog].posicao:= '0';
          salvarJog(jog);
          jogs[jog].socket.SendText(#13#10 + 'Jogador criado!');
          mandarPos(jog);
     end;
end;

procedure TForm1.cmdAndando(jog: integer);
var
str: TParsedString;
begin
     if jogs[jog].cmd = '' then exit;        //se for um comando em branco
     str:= parseString(jogs[jog].cmd, ' ');  //separar pelos espaos

     if jogs[jog].cmd = 'olhar' then               //se for "olhar" para a posio
       mandarPos(jog)
     else if TentarSair(jog) then                  //testar por sadas
       exit
     else if jogs[jog].cmd = 'quem' then           //lista de jogadores
       MandarConectados(jog)
     else if str.strings[0] = 'falar' then         //chat para todos os jogadores
       falar(jog)
     else if str.strings[0] = 'dizer' then         //chat para um jogador
       dizer(jog, str)
     else if str.strings[0] = 'pegar' then         //pegar um objeto do cenrio
       pegar(jog, str)
     else if jogs[jog].cmd = 'inventario' then     //mostrar contedo do inventrio
       mostrarInv(jog)
     else if str.strings[0] = 'soltar' then        //soltar um objeto do inventrio
       soltar(jog);
end;

procedure TForm1.mandarPos(jog: integer);
var
stl: TStringList;
lin: integer;
s: string;
str: TParsedString;
begin
     stl:= TStringList.create;
     stl.loadFromFile(jogs[jog].posicao);                 //carregar posio
     lin:= 0;
     jogs[jog].socket.sendText(#13#10);                   //pular linha
     while stl[lin] <> '*' do begin                       //mandar descrio at o fim
          jogs[jog].socket.SendText(stl[lin] + #13#10);
          lin:= lin + 1;
     end;
     lin:= lin + 1;
     s:= 'Sadas: ';                                      //pegar sadas
     if lin < stl.count then
          while stl[lin][1] = '#' do begin
               str:= parseString(stl[lin], ',');
               s:= s + '[' + str.strings[1] + ']';
               lin:= lin + 1;
               if lin >= stl.count then break;
          end;
     jogs[jog].socket.sendText(s + #13#10);              //mandar sadas
     s:= 'Itens: ';
     if lin < stl.count then                             //pegar itens
          while stl[lin][1] = '+' do begin
               str:= parseString(stl[lin], ',');
               s:= s + '[' + str.strings[1] + ']';
               lin:= lin + 1;
               if lin >= stl.count then break;
          end;

     jogs[jog].socket.sendText(s + #13#10);              //mandar itens

     stl.free;
end;

function TForm1.TentarSair(jog: integer): boolean;
var
stl: TStringList;
lin: integer;
str: TParsedString;
begin
     result:= false;
     stl:= TStringList.create;
     stl.loadfromfile(jogs[jog].posicao);
     lin:= stl.IndexOf('*') + 1;
     while stl[lin][1] = '#' do begin
          str:= parseString(stl[lin], ',');
          if jogs[jog].cmd = str.strings[1] then begin
               jogs[jog].posicao:= str.strings[2];
               MandarPos(jog);
               result:= true;
               break;
          end;
          lin:= lin + 1;
          if (lin > stl.count -1) or (result) then break;
     end;
     stl.free;
end;

procedure TForm1.MandarConectados(jog: integer);
var
i: integer;
begin
     jogs[jog].socket.SendText('==== Lista de Conectados ===' + #13#10);
     for i:= 0 to length(jogs) -1 do
          jogs[jog].socket.SendText(jogs[i].nome + #13#10);
end;

procedure TForm1.MandarTodos(s: string);
var
i: integer;
begin
     for i:= 0 to length(jogs) -1 do
          jogs[i].socket.sendText(s);
end;

function TForm1.AcharJog(nome: string): integer;
var
i: integer;
begin
     result:= -1;
     for i:= 0 to length(jogs) -1 do
          if jogs[i].nome = nome then begin
               result:= i;
               break;
          end;
end;

procedure TForm1.Falar(jog: integer);
var
msg: string;
begin
     msg:= copy(jogs[jog].cmd, 7, length(jogs[jog].cmd));
     mandarTodos(jogs[jog].nome + ' falou "' + msg + '"' + #13#10);
end;

procedure TFOrm1.Dizer(jog: integer; str: TParsedString);
var
dest: integer;
s: string;
begin
     dest:= acharJog(str.strings[1]);
     if dest = -1 then begin
          jogs[jog].socket.SendText('Jogador no existe' + #13#10);
          exit;
     end;
     s:= copy(jogs[jog].cmd, 7 + length(str.strings[1]) + 1, length(jogs[jog].cmd));
     jogs[dest].socket.SendText(jogs[jog].nome + ' disse "' + s + '"' + #13#10);
end;

procedure TForm1.Pegar(jog: integer; str: TParsedString);
var
stl: TStringList;
lin: integer;
item: TParsedString;
begin
     stl:= TStringList.create;
     stl.loadFromFile(jogs[jog].posicao);         
     lin:= stl.IndexOf('*');
     for lin:= lin to stl.count -1 do
          if stl[lin][1] = '+' then begin
               item:= parseString(stl[lin], ',');
               if pos(str.strings[1], item.strings[1]) > 0 then begin
                    stl.Delete(lin);
                    stl.SaveToFile(jogs[jog].posicao);
                    jogs[jog].inventario:= jogs[jog].inventario + item.strings[1] + ',';
                    jogs[jog].socket.SendText('Voc pegou ' + item.strings[1] + #13#10);
                    break;
               end;
          end;

     stl.free;
end;

procedure TForm1.MostrarInv(jog: integer);
var
i: integer;
str: TParsedString;
begin
     jogs[jog].socket.sendText('=== Inventrio ===' + #13#10);
     if jogs[jog].inventario = '' then begin                //se o inventrio estiver vazio
          jogs[jog].socket.sendText('<nada>' + #13#10);
          exit;
     end;
     str:= parseString(jogs[jog].inventario, ',');
     for i:= 0 to str.count -1 do                           //se tiver alguma coisa
          jogs[jog].socket.sendText(str.strings[i] + #13#10);
end;

procedure TForm1.Soltar(jog: integer);
var
i, j: integer;
inv: TParsedString;
item: string;
stl: TStringList;
begin
     inv:= parseString(jogs[jog].inventario, ',');
     item:= copy(jogs[jog].cmd, 8, length(jogs[jog].cmd));
     for i:= 0 to inv.count -1 do
          if pos(item, inv.strings[i]) > 0 then begin
               stl:= TStringList.create;
               stl.loadFromFile(jogs[jog].posicao);
               stl.Add('+,' + inv.strings[i]);
               stl.SaveToFile(jogs[jog].posicao);
               stl.free;
               jogs[jog].inventario:= '';
               for j:= 0 to inv.count -1 do
                    if j <> i then jogs[jog].inventario:= jogs[jog].inventario + inv.strings[j] + ',';
               jogs[jog].socket.SendText('Voc soltou ' + inv.strings[i] + #13#10);
               break;
          end;
end;


end.
